/*
    This file is part of lorcon

    lorcon is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    lorcon is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with lorcon; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Copyright (c) 2005 dragorn and Joshua Wright
*/

#include "config.h"

#include <string.h>
#include <netinet/in.h>
#include <stdlib.h>
#include <stdio.h>

#include "packetforge.h"
#include "ieee80211.h"
#include "endian_magic.h"

uint8_t *ouilist[] = {
    (uint8_t *) "\x00\x01\x03", (uint8_t *) "\x00\x01\x24",
    (uint8_t *) "\x00\x02\x2D", (uint8_t *) "\x00\x02\x6F",
    (uint8_t *) "\x00\x02\xA5", (uint8_t *) "\x00\x03\x2F",
    (uint8_t *) "\x00\x04\x3A", (uint8_t *) "\x00\x04\x5A",
    (uint8_t *) "\x00\x04\x75", (uint8_t *) "\x00\x04\xE2",
    (uint8_t *) "\x00\x05\x5D", (uint8_t *) "\x00\x06\x25",
    (uint8_t *) "\x00\x07\x0E", (uint8_t *) "\x00\x07\x50",
    (uint8_t *) "\x00\x08\x21", (uint8_t *) "\x00\x09\x43",
    (uint8_t *) "\x00\x09\x5B", (uint8_t *) "\x00\x09\x7C",
    (uint8_t *) "\x00\x09\x92", (uint8_t *) "\x00\x09\xE8",
    (uint8_t *) "\x00\x0A\x41", (uint8_t *) "\x00\x0A\x8A",
    (uint8_t *) "\x00\x0C\x41", (uint8_t *) "\x00\x0D\x88",
    (uint8_t *) "\x00\x30\x65", (uint8_t *) "\x00\x30\xAB",
    (uint8_t *) "\x00\x30\xBD", (uint8_t *) "\x00\x40\x05",
    (uint8_t *) "\x00\x40\x26", (uint8_t *) "\x00\x40\x96",
    (uint8_t *) "\x00\x50\x08", (uint8_t *) "\x00\x50\x8B",
    (uint8_t *) "\x00\x50\xDA", (uint8_t *) "\x00\x50\xF2",
    (uint8_t *) "\x00\x60\x01", (uint8_t *) "\x00\x60\x1D",
    (uint8_t *) "\x00\x60\x6D", (uint8_t *) "\x00\x60\xB3",
    (uint8_t *) "\x00\x80\x37", (uint8_t *) "\x00\x80\xC6",
    (uint8_t *) "\x00\x80\xC8", (uint8_t *) "\x00\x90\x4B",
    (uint8_t *) "\x00\x90\xD1", (uint8_t *) "\x00\xA0\x04",
    (uint8_t *) "\x00\xA0\xF8", (uint8_t *) "\x00\xE0\x29",
    (uint8_t *) "\x08\x00\x46", NULL
};

void lcpf_createrandmac(uint8_t *addr) {
    int listlen = 0;

    while (ouilist[listlen] != NULL) {
        listlen++;
    };

    memcpy(addr, ouilist[rand() % listlen], 3);
    addr[3] = rand() % 255;
    addr[4] = rand() % 255;
    addr[5] = rand() % 255;
}

lcpf_packet *lcpf_packet_init(int in_carriermax, uint8_t in_type, uint8_t in_subtype, 
                              uint8_t *in_addr0, uint8_t *in_addr1, uint8_t *in_addr2) {
    lcpf_packet *pak;

    pak = (lcpf_packet *) malloc(sizeof(lcpf_packet));
    pak->raw_buf = (uint8_t *) malloc(in_carriermax);
    pak->maxlen = in_carriermax;
    pak->len = IEEE80211_HDRLEN;
    pak->ieee_header = &(pak->raw_buf[0]);
    pak->append_ptr = &(pak->raw_buf[len]);
    pak->nr_tagparms = 0;

    memset(pak->ieee_header, 0, sizeof(ieee80211_hdr));

    pak->ieee_header = host_to_le16((in_type << 2) | (in_subtype << 4));

    memcpy(pak->ieee_header->addr1, in_addr1, 6);
    memcpy(pak->ieee_header->addr2, in_addr2, 6);
    memcpy(pak->ieee_header->addr3, in_addr3, 6);

    return pak;
}

void lcpf_packet_destroy(lcpf_packet *mod_packet) {
    free(mod_packet->raw_buf);
    free(mod_packet);
}

int lcpf_packet_addtagparm(int in_parm, int in_len, uint8_t *in_data, 
                           lcpf_packet *mod_packet) {
    if (mod_packet->

}

int PacketForgeDeauth(uint8_t *in_bssid, uint8_t *in_source, 
                      uint8_t *in_dest, uint8_t **ret_frame) {
    struct ieee80211_mgmt txheader;
    int len;
    
    memset(&txheader, 0, sizeof(txheader));

    txheader.frame_control = host_to_le16(WLAN_FC_TYPE_MGMT << 2) | 
        (WLAN_FC_SUBTYPE_DEAUTH << 4);

    // Fill in the addresses
    memcpy(txheader.bssid, in_bssid, 6);
    
    if (in_source != NULL)
        memcpy(txheader.sa, in_source, 6);
    else
        memcpy(txheader.sa, in_bssid, 6);

    if (in_dest != NULL)
        memcpy(txheader.da, in_dest, 6);
    else
        memset(txheader.da, 0xFF, 6);

    // Fill in the reason
    txheader.u.deauth.reason_code = host_to_le16(WLAN_REASON_PREV_AUTH_NOT_VALID);

    // Alloc and copy it into the return buffer
    len = (IEEE80211_HDRLEN + sizeof(txheader.u.deauth));

    *ret_frame = new uint8_t[len];
    memcpy(*ret_frame, &txheader, len);

    return len;
}

int PacketForgeDisassoc(uint8_t *in_bssid, uint8_t *in_source,
                        uint8_t *in_dest, uint8_t **ret_frame) {
    struct ieee80211_mgmt txheader;
    int len;

    memset(&txheader, 0, sizeof(txheader));

    txheader.frame_control = host_to_le16((WLAN_FC_TYPE_MGMT << 2) |
        (WLAN_FC_SUBTYPE_DISASSOC << 4));

    // Fill in the addresses
    memcpy(txheader.bssid, in_bssid, 6);
    
    if (in_source != NULL)
        memcpy(txheader.sa, in_source, 6);
    else
        memcpy(txheader.sa, in_bssid, 6);

    if (in_dest != NULL)
        memcpy(txheader.da, in_dest, 6);
    else
        memset(txheader.da, 0xFF, 6);

    txheader.u.disassoc.reason_code = host_to_le16(WLAN_REASON_PREV_AUTH_NOT_VALID);

    len = (IEEE80211_HDRLEN + sizeof(txheader.u.disassoc));
    *ret_frame = new uint8_t[len];
    memcpy(*ret_frame, &txheader, len);

    return len;
}

int PacketForgeAssocReq(uint8_t *in_bssid, uint8_t *in_source, const char *in_ssid,
                        int in_wep, uint8_t **ret_frame) {
    // Highly influenced by some old airjack code and void11
    struct ieee80211_mgmt txheader;
    int len;
    uint8_t *variable;
    int vlen;

    memset(&txheader, 0, sizeof(txheader));

    // Variable = 1b tag 1b len Xb ssid 1b tag 1b size 4b supprates
    vlen = 8 + strlen(in_ssid);
    variable = new uint8_t[vlen];

    txheader.frame_control = host_to_le16((WLAN_FC_TYPE_MGMT << 2) |
        (WLAN_FC_SUBTYPE_ASSOCREQ << 4));

    // Fill in random if we weren't given a source to assoc from
    if (in_source == NULL) 
        PacketForgeCreateRandmac(txheader.sa);
    else
        memcpy(txheader.sa, in_source, 6);

    memcpy(txheader.da, in_bssid, 6);
    memcpy(txheader.bssid, in_bssid, 6);

    // Set the capability fields
    txheader.u.assoc_req.capab_info = host_to_le16(WLAN_CAPABILITY_ESS);
    if (in_wep)
        txheader.u.assoc_req.capab_info |= host_to_le16(WLAN_CAPABILITY_PRIVACY);

    txheader.u.assoc_req.listen_interval = host_to_le16(1);

    int voff = 0;
    variable[voff++] = WLAN_TAGPARM_SSID;
    variable[voff++] = strlen(in_ssid);
    memcpy(&(variable[voff]), in_ssid, strlen(in_ssid));
    voff += strlen(in_ssid);
    variable[voff++] = WLAN_TAGPARM_SUPPRATES;
    variable[voff++] = 4;
	variable[voff++] = 0x82; // 1mbit
    variable[voff++] = 0x84; // 2mbit
    variable[voff++] = 0x0b; // 5.5
    variable[voff++] = 0x16; // 11

    // Play some games copying the variable after the standard frame
    len = (IEEE80211_HDRLEN + sizeof(txheader.u.assoc_req));
    *ret_frame = new uint8_t[len + vlen];
    memcpy(*ret_frame, &txheader, len);
    memcpy((*ret_frame) + len, variable, vlen);
    len += vlen;

    delete[] variable;
    return len;
}

int PacketForgeAuth(uint8_t *in_source, uint8_t *in_dest, uint8_t **ret_frame) {
    // Highly influenced by some old airjack code and void11
    struct ieee80211_mgmt txheader;
    int len;

    memset(&txheader, 0, sizeof(txheader));
    
    txheader.frame_control = host_to_le16((WLAN_FC_TYPE_MGMT << 2) |
        (WLAN_FC_SUBTYPE_AUTH << 4));

    // Fill in random if we weren't given a source to assoc from
    if (in_source == NULL) 
        PacketForgeCreateRandmac(txheader.sa);
    else
        memcpy(txheader.sa, in_source, 6);

    memcpy(txheader.da, in_dest, 6);
    memcpy(txheader.bssid, in_dest, 6);

    txheader.u.auth.auth_alg = host_to_le16(0);
    txheader.u.auth.auth_transaction = host_to_le16(1);
    txheader.u.auth.status_code = host_to_le16(0);

    len = (IEEE80211_HDRLEN + sizeof(txheader.u.auth));
    *ret_frame = new uint8_t[len];
    memcpy(*ret_frame, &txheader, len);
    
    return len;
}

int PacketForgeProbeReq(uint8_t *in_source, const char *in_ssid, uint8_t **ret_frame) {
    // Highly influenced by some old airjack code and void11
    struct ieee80211_mgmt txheader;
    int len;
    uint8_t *variable;
    int vlen;

    memset(&txheader, 0, sizeof(txheader));

    // Variable = 1b tag 1b len Xb ssid 1b tag 1b size 4b supprates
    vlen = 8 + strlen(in_ssid);
    variable = new uint8_t[vlen];

    txheader.frame_control = host_to_le16((WLAN_FC_TYPE_MGMT << 2) |
        (WLAN_FC_SUBTYPE_PROBEREQ << 4));

    // Fill in random if we weren't given a source to probe from
    if (in_source == NULL) 
        PacketForgeCreateRandmac(txheader.sa);
    else
        memcpy(txheader.sa, in_source, 6);

    memset(txheader.da, 0xFF, 6);
    memset(txheader.bssid, 0xFF, 6);

    int voff = 0;
    variable[voff++] = WLAN_TAGPARM_SSID;
    variable[voff++] = strlen(in_ssid);
    memcpy(&(variable[voff]), in_ssid, strlen(in_ssid));
    voff += strlen(in_ssid);
    variable[voff++] = WLAN_TAGPARM_SUPPRATES;
    variable[voff++] = 4;
	variable[voff++] = 0x82; // 1mbit
    variable[voff++] = 0x84; // 2mbit
    variable[voff++] = 0x0b; // 5.5
    variable[voff++] = 0x16; // 11

    // Play some games copying the variable after the standard frame
    len = (IEEE80211_HDRLEN + sizeof(txheader.u.probe_req));
    *ret_frame = new uint8_t[len + vlen];
    memcpy(*ret_frame, &txheader, len);
    memcpy((*ret_frame) + len, variable, vlen);
    len += vlen;

    delete[] variable;
    return len;
}

